# Antevs History

1.7.0.43 (05-2022)
* User Manual is now a separate download.
* Added Help menu command to open User Manual.
* Udpdated User Manual.
* Fixes to Dark Theme display.
* Added GitHub url link in Help menu.
* Added macOS M1 version.
* Fixes to EPS vector graphics.
* Added PDF vector graphics
* Added autocorrelogram plot.
* Added lag 1 autocorrelation removal.
* Code refactoring.

1.6.1.4 (2021-09-05)
* Updates and fixes (FPC 3.2.0, LCL 2.0.12).

1.6.0.9 (2020-07-19)
* No longer localizes decimal separator due to bugs in file output. This may change in future releases. 
* Fixed potential errors in fetching URL text.
* Extensive rewrite of user manual.
* Fixes to data edit spreadsheet.
* Fixes to Mac interface (LCL 2.0.8 update). 

1.5.0.14 (2019-08-16)
* Updated preference files from XML to JSON. Files are converted when accessed.
* Added “View Metadata” command.
* Macintosh version is now 64 bit Cocoa.
* Fixed bug in writing Excel and LibreOffice spreadsheet files.
* Fixed reading of crn files that contain a last line of decimal data.
* Fixed writing of crn files that use the Standardized detrend method. The data is rescaled from 0.0 to positive values such that the mean value is 1.0. 
* Added option in Detrend pane of Preferences dialog to allow mean master files to be detrended.
* Added option in Filter pane of Preferences dialog to allow mean master files to be filtered.
* Added the ability to read and write NOAA chronology format (noaa.crn) files.
* Added the ability to read individual series (e.g., RAW, STD, etc.) from a Tucson crn file that contains multiple series.
* Numerous changes related to code refactoring and development environment updates.
* Implemented High DPI scaling code for Windows 150% and 200% modes, including new icon sets.
* Fixes to allow localization by country of decimal separators other than decimal point. Files use decimal point separators. 

1.4.1.1 (2018-06-26)
* Fixed icon.
* Fixed serial port connection.

1.4.0.6 (2018-06-18)
* Added Sliding correlation option to Bin test. 
* Preferences dialog updated with listbox control.
* Fixes to text controls, replaced all TStaticText controls with TLabels.
* Updated math and statistics routines to use open source library, e.g., non-linear curve fitting using Levenberg-Marquardt method, and linear equation solutions with LU decomposition  from Jean Debord’s DMath 0.9.0.
* Rewrote linear, quadratic, and cubic curve fitting routines from scratch to remove external dependencies.
* Removed all TIdleTimers that were used to enable menus and controls. The controls are now updated as necessary in command and message procedures.
* Updated with Lazarus 1.8.4 and Free Pascal 3.0.4.
* Numerous code refactoring changes.

1.3.6.4 (2016-12-03)
* Fixed and improved segment editing. Now segments can be slid forwards and backwards, and individual segments move independently.
* Now displays years in short segments without decimal points
* Fixed delete selected year in series editing window, was deleting the last year instead of selected year.
* Fixed a divide by zero bug that occurred during the display of a series with two data points.
* Fixed About box display.

1.3.5.5 (2016-11-21)
* Changed messaging procedures from PostMessage to Dispatch message.
* Fixed metadata editing in spreadsheet file formats.
* Fixed initial year assignment bug.
* Added Home Page command.
* Added automatic version checking, and Check for Updates command.
* Updated grids.
* Segment editing entirely replaced, see Section 6.2.
* Graph Window renamed Plot Window.

1.3.4.1 (2016-04-27)
* Fixed display of segments when reopening file saved with NaN values.

1.3.3.7 (2016-04-03)
* Now automatically renumbers when inserting a NaN during graphical editing.
* Saves and reads three lines of metadata in Tucson decadal crn files.
* Now correctly reads Tucson decadal rwl files with negative years.
* New command Edit Metadata to edit metadata.
* After data is entered in the Data Edit window with the Vemlex recording device, the window can now be closed without the Accept Edits warning.
* Edit New now allows more than one “untitled” files.
* In file window mouse Shift-Click selection now selects a block of rows. Command-Click (Control-Click) toggles one row as previously.
* Fixed status display in the Graph window.
* Removed the confusing Break Segment command. Now, in Edit Segments mode clicking inside a segment cuts it (click again to undo), and clicking on the start of a segment selects it. See Section 6.2.

1.3.2.4 (2016-02-22)
* Bound resource files into executable for Windows and Linux.
* Added back Zoom Data toolbar pan buttons, press Shift to pan to first or last year.
* Added saving of comments to mean master file.
* Added Encapsulated Postscript and DXF vector export.
* Consolidated graphics output to Export Image commands.
* Added Page Size command for Data Graph and Correlograms.
* Work on User Manual, including Chapter 8 to clarify Data Windowing.
* Removed “Unknown” and “Chronology” from Data Graph legend.
* Compiled with LCL 1.6.0 and FPC 3.0.0 optimizations.
* Fixed 999 bug in RWL writing.

1.3.1.14 (2016-02-13)
* Optimized data grid scrolling.
* Optimized messaging.
* Remembers last data file directory.
* Fixed index range bug in splines.
* Data plots now update during editing in Data Window.
* Correlogram now correctly updates when no data list is selected, and when lists are opened or closed.
* The edited state can now be saved by the Accept Edits command either during editing in the data window, or during editing using the Edit Segments command in the plot window. The Cancel Edits command restores to that state. 
* Removed Refresh toolbar button, Auto-Refresh is on by default.
* Removed Zoom Window pan toolbar buttons from Plot Window, the Cmd-[ (Pan Left) and Cmd-] (Pan Right) and Shift Cmd-[ (Pan First) and Shift Cmd-] (Pan Last) keys are now enabled for this.
* Added automatic renumbering for edit operations. This already occurs for segment editing.
* Added automatic ID assignment for editing. The ID is always a unique number.
* If no IDs are input a sequential value starting at 1 will be assigned.
* Added ability to change plot frame color, default is now black with while background.
* Added additional icon sizes for Windows 7 and up.
* Added Reverse Segment command.
* Cleaned up some dialog control display issues. 
* Now reads rwl files containing non-standard LFLF sequences output by some software.
* The rwl file units  are now correctly set during reading by checking for stop markers “999” (0.01 mm) or “-9999”  (0.001 mm) in file (Cybis Wiki contributors, 2015). Note “999” stop marker disallows 9.99 mm rings in 0.01 mm files. 
* Changes to 0.001 mm rwl file reading and writing following D. Barclay (per J. Rayburn). Writing uses “-9” instead of “0”. Reading treats any negative value as missing, not “0”. See Cybis Wiki contributors (2015) for “0” convention. 
* Changes to reading and writing missing values in 0.01 mm rwl files following Cybis Wiki contributors (2015). Writing uses “-999”. Reading treats any negative value as missing.
* Added reading of rwl meta-data headers.
* Added writing of meta-data headers.

1.3.0.3 (2015-06-29)
* Serial Settings, Initialize Read, Split,  and Preferences dialogs re-configured for better cross-platform consistency. Additional tooltip help added. TLabel controls replaced with TStaticText.
* Added “ID” column to provide a unique identifier for each measurement to allow editing of years without losing track of initial input values. See Section 5. Feature request by Andrew Breckenridge.
* Added command to set the ID from the Year. This will change the ID to the current year, and would normally only be done during initial measurements.
* Fixed the reading of spreadsheet files (ods, xls, xlsx) so column order is not important. 
* Made “Ratio Log” a separate method option instead of using checkboxes, this uses the Ratio method followed by log normalization (COFECHA option). A combobox allows separate methods for unknowns and chronologies. 
* Numerous internal changes to preferences code for easier updates.
* Added visual segment editing for missing data and broken cores with 6 new segment analysis commands, see Section 5.  
* New icon. 

1.2.1.1 (2015-01-29)
* Made default for treat negative as NaN to false to avoid problems with mean series when using standardized detending.
* Fixed bug causing crash when renaming Chronology.
* Fixed widths in initial display of columns.
* Currently line count: 159,471.

1.2.0.13 (2015-01-07)
* Added StatusBars to MainWindow and DataWindow.
* Replaced Timers with Messages to communicate between windows.
* Replaced StringGrids with DrawGrids to avoid internal data duplication.
* Numerous internal changes for utilizing Messages and DrawGrids, resulting in more maintainable code for future updates. 
* Grayed uneditable cells in grids.
* Fixed LogForm to open in front when Preferences > Options > Display log is checked.
* Added date time string to LogForm, and added left margin.
* Added Unknown and Chronology dates to Correlogram status bar. The correlogram status bar now contains all information contained in the Log file.
* Fixed 'Save As' command to rename file in MainWindow grids.
* Changed 'Clear' to 'Close' in file close warning dialogs.
* Fixed the extra warning dialog when closing a file modified in the DataWindow.
* Modified to 'Revert' command. In the Data Window, Cancel Edits reverts to the last state saved with Accept Edits, while Revert returns to the state when the file was opened.
* Numerous changes to Data Edit Window input procedures. Current mode and user instructions are provided in the status bar (instead of dialog boxes) to clarify. A default year is given (1900), which can be edited. Data may be entered manually or using the recorder. The modes: Disconnected, Connected, Initializing, and Recording are indicated in the status bar, as well as by the Record button (gray, red, yellow, green). Mode changes also have audible cues.
* Fixed Error Opening File dialog to display file name.
* Fixed an error that cleared the file list when opening a new ods, xls, or xlsx file.
* Updated the spreadsheet opening/saving component. Previously a file open in Excel or LibreOffice could not be opened simultaneously in Antevs due to file privileges. It is now possible to do so, however, with the risk of file version collision. Save the file in one program before opening it in the other.
* DataWindow tool hint "Insert Row" changed to "Insert Row Before".
* DataWindow Append button switched position with Insert.
* Changed default bin size from 100 to 50, and minimum overlap from 60 to 50.
* Added mouse-over status to Frequency Graph. This is an experimental graph, and its interpretation is not straight-forward. It is a periodogram, a modulus-squared of the Fourier transform.
* Added "Time" as input alias header for "Year", to accommodate monthly, hourly, etc., time series.
* Missing data is now supported, see Section 5.

1.1.0.3 (2014-10-04)
* Updated to minor version 1.
* Internal modifications to file save routines.
* Changed Edit > Clear command to File > Close, and added Cmd-W accelerator key.
* Changed Auto-Update default to true.
* Grids now save column widths between sessions.
• 	Moved Analyze > Refresh to View > Refresh, fixed disabled command when Auto-Update is off, changed accelerator key from Cmd-H to Cmd-R.
* Paint pickers updated to use opacity.
* Added ability to open Excel XLS and XLSX files.
* Fix to correctly save initial comment lines in File > Save As.
* Modified data collection routines to ask for initial date.
* Linux: Fixed image centering bug using work around.
* Linux: Fixed Preference dialog so visible pane always matches panel listbox selection.
* Expanded User Manual.

1.0.6.6 (2014-02-23)
* Numerous changes to the Data Edit Window to implement reading the Velmex UniSlide digital readout for logging tree-ring data. See section in ANTEVS User Manual on Data Collection.
* Implemented messaging to replace global flags and minimize recalculations.
* Fixed and bug that was disallowing multiple open series for some formats.
* Added warnings for saving data.
* Disallowed opening series with identical names. 
* Fixes to File Save dialog.
* Added Save As command to Data Edit window.
* Changed the name from ANTEVS (Automatic Numerical Time-series Evaluation of Varve Sequences) to ANTEVS (Automated Numerical Time-series Evaluation of Varying Sequences).

1.0.5.9 (2013-04-29)
* Fixed Revert command in data edit window. This command reverts the data to the last time it was opened or saved.
* Added Select All command.
* Removed depreciated Clear All command, use Select All + Clear commands.
* Made Precision apply to displayed data as well as file output.
* Added ODS (OpenDocument), XLS, and XLSX spreadsheet formats to Save As command. 
* Added Export Sets command to save all selected data sets in one TSV, CSV, ODS, XLS, XLSX, or RWL (decadal) format file. See Brewer et al., 2011.
* Added ODS spreadsheet format to Open command.
* Open command now detects and opens TSV, CSV, ODS files, in addition to RWL format files, to open multiple sets files created with Export Sets command. 

1.0.4.10 (2013-04-22)
* Grouped graph components in SVG output for easier editing.
* Fixed text vertical alignment in SVG output.
* Changed menu item Save As Vector Graphics to Export SVG.
* Removed Unicode => symbol, not recognized by AI Helvetica.
* Added target CPU and system info to About dialog box.
* Added comment editing.
* Added Split command to split, join and renumber data measurements.
* Removed depreciated Combine command.
* Preference file modifications.

1.0.3.7 (2013-04-08)
* Fixed floating point error caused if detrend curve exactly equals data.
* Fixed preference button hints.
* Allow opening of Preference dialog without selecting or opening data. 
* Added menu options to open Preference dialog Detrend and Filter pages.
* Added fit curve color selection.
* Added About dialog.
* Compiled with FPC 2.6.2, LCL 1.0.8.

1.0.2.5 (2013-04-01)
* Fixed bug causing freeze when opening Precision dialog.
* Precision now stored in preference file.
* Precision settings moved to Preferences dialog.
* Added ANTEVS header to TXT files.
* Changed default file type to TSV (tab separated values).
* Modified Save As for TXT, TSV, CSV files to save Year and Raw columns only.
* Added z score, standard deviation, count,  and offset to cross-correlation graph.
* Changed precision to three places in cross-correlation display.
* Displayed maximum t value now always corresponds to maximum r value.
* Added p to t graph.
* Changed title of 'Filters' dialog box to 'Preferences'.
* Changed page selection in preference dialog to combobox.
* Detrend, Filters, and View preferences are now saved to preference file.
* Added option to turn off display of cross-correlation significance in Preferences Options tab.
* Added stroke selection for graph data.
* Fixed runs trend bug.

1.0.1.4 (2013-03-16)
* Compiled with Free Pascal 2.6.0 and Lazarus 1.0.6.
* Fixed missing tick marks bug. 
* Fixed tick marks stroke color.
* Fixed vector font export bug, fonts are now filled instead of stroked.
* Fixed incorrect log references.
* Fixed fill color bug in SVG export.

1.0.0.1 (2012-10-31)
* First official release for review.

0.0.20 (2012-09-18)
* Compiled with Free Pascal 2.6 and Lazarus 1.0.
* Fixed Save As command to save raw data instead of detrended data.
* Added new Save Detrend command saves detrended data.
* Added preliminary frequency spectrum (periodogram) graph, use Window > Frequency to view.

0.0.19 (2012-04-15)
* Added multiple colors to data graph.

0.0.18 (2012-04-08)
* Recompiled on Free Pascal 2.6.0.
* Added Spline detrending, following COFECHA. 
* Added Log transform for the Ratio method, following COFECHA.
* Added csv and tsv data files for both raw data and mean masters. 
* Combined file formats into Open and Save As dialogs, and removed multiple Open and Save As commands.
* Removed Delta bar past filter. 
* Added Link checkbox to link unknown and chronology detrend methods.
* Added max and mean labels to correlogram and bin graphs.
* TODO: Interpolate missing values.
* TODO: Debug RWL and CRN missing value and end data values, 999, -999, -9999, etc.

0.0.17 (2012-02-24)
* Added ability to select and view multiple data sets by control (Windows) or command (Mac) clicking. Note that only the first selected file in the unknown and chronology grids is used for most operations (cross correlation, saving files, etc.).
* Added data windowing with panning to allow detailed view and stepping through data.
* Added cross-correlation of data window.
* Added Count column in data edit grid, this gives data counts for means and CRN files.
* Fixed memory leak.
* Added Save As CRN Chronology for mean and CRN data series.  
* Enabled Preferences command on Mac (same as Filters).

0.0.16 (2012-02-05)
* Added Fourier detrending for variable terms. 
* Added two delta filters mainly for use with Standardize detrend method. These are more stable and handle zero thicknesses naturally (no division by zero). Note the Cubic derivative is also stable. Note that the common Ratio method normalize filters do not work well with the Standardize detrend method, because the mean is zero instead of one.
* Added Delta bar filter: y1' = y1 - (y0+y1+y2)/3.
* Added Delta bar past filter: y3' = y3 - (y0+y1+y2)/3. 
* Removed Difference filter, this was identical to Delta bar past with 1 term.
* Removed polynomial smoothing detrending as not effective, was similar to Fourier with many terms.
* Removed quadratic polynomial derivative filter as not effective, overly smoothed data.
* Added mean toolbutton.
* Added detrend Fit method, this gives the fit curve for display or saving to file. It is not useful for correlation.
* Stacked raw, detrend, and filtered data graphs.
* Numerous additional fixes.

0.0.15 (2012-02-19)
* Changed name to ANTEVS (Automated Numerical Time-series Evaluation of Varve Sequences), or Antevs.
* Added automatic option for detrending polynomial curve fitting. See Detrend above.
* Changed automatic exponential to reject linear fits that predict negative thicknesses. This removes some errors in detrending (e.g., calculating a mean for ny005.rwl, series 22).
* Added orthogonal quadratic polynomial smoothing filters. See Normalize above.
* Added orthogonal quadratic and cubic polynomial first derivative filters. See Normalize above. 
* No longer saves window size when maximized.
* Added residuals and standard residuals detrend methods. See Detrend above.
* Added data series name edit.
* Made Filters dialog nonmodal.
* Added Detrended column to Data Edit grid.
* Enabled Quit command in Windows.

0.0.14 (2012-02-16)
* Fixed saving of mean files.
* Rewrote handling of zero thicknesses, only used during normalization to avoid division by zero or log zero. 
* Stacked graphs with scales on all curves.
* Fixed update of Data Edit grid when a chronology is viewed.
* Fixed update of main data set grid after editing data.
* Optional runs trend calculation is done simultaneously and viewed on a separate stacked graph.
* Runs trend algorithm is modified slightly following Corina; an up/down/same = up/down/same match gets +1, a same = up/down gets +0.5, otherwise no match gets 0.

0.0.13 (2012-02-06)
* Rewrote cross-correlation procedure to minimize potential round off, no change in functionality.
* Fixed bug in graph frame drawing.
* Fixed bug in exponential fitting, was not fully converging.
* Added y scale labels to data graph for raw data on right. Filtered data scale remains on left. Grid is drawn for filtered data unless only raw or detrend fit is on. 
* Fixed Clear tool button, was not working.
* Fixed two bugs causing random errors in mean calculation.
* Changed menu text from "Cross-Correlation" to "Correlation", no change in functionality.

0.0.12 (2012-02-05)
* Added Zoom commands and controls, including mouse dragging.
* Fixed Accept Edits command in Data Edit window, was not keeping edits.
* Changed Processed to Filtered for clarity.
* Changed Data View to Data Edit.
* Added toolbar to Data Set window.
* Added data names to graphs.
* Fixed y axis scaling error on data graph.
* Added correlogram caption.
* Linked Filter Normalize controls, so changing unknown now changes chronology. Added an option to turn linking off, but there is no reason for these to differ. May combine in next version.
* Fixed Save As, was not enabled.
* Added more information in status bar.

0.0.11 (2012-01-28)
* Added graphics buffer to fix slow redraw on Windows. 
* Fixed focus loss when closing filters dialog on Windows.
* Fixed divide by zero error

0.0.10 (2012-01-28)
* Fixed window position xml preferences
* Fixed error reading rwl, 999 entries now excluded as well as -9999
* Fixed data view, was not updating on data grid focus change
* Enabled view detrend as always available
* Fixed error in mean calculation, was not detrending with correct settings
* Added save view options in preferences
* Fixed divide by zero error

0.0.9 (2012-01-25)
* Internal changes for easier maintanence
* Fixed compatibility with OS X 10.5

0.0.8 (2012-01-18)
* Added graph of offset values to bin test correlogram.
* Added color keys for curves on graphs.
* Restored ability to calculate mean chronology.
* Restored option to view log output.
* Fixed bugs in bin test.
* Made auto-refresh optional.
* Added Refresh command and toolbar buttons.
* Fixed label and grid spacings to auto-size.
* Added ability to open CRN files.
* Added ability to detect and  open four column TXT files.
* TXT file is checked for non-sequential values.
* Added Open command that uses file extension to determine file type.
* Added quadratic and cubic detrending options.
* Turned off automatic renumbering when editing a file.
* Added Renumber command.

0.0.7 (2012-01-08)
* Completed graphical display of bin test and data display.
* Simplified analyze options.
* Depreciated log test display window.
* Added curve fitting and detrending algorithms.
* Implemented Marquardt non-linear curve fitting.
* Added best-fit curve display to data graph window.
* Redesignated growth correlations as normalize filters, e.g., Natural and Difference.
* Added additional normalize filters, e.g., Log five year and Two year sum.
* Depreciated cross-association (available in Filters Extra tab).
* Depreciated runs analysis (available in Filters Extra tab as SIgn).
* Experimental implementation of area correction algorithm (depreciated).
* Implemented chronology data display. 
* Implemented unknown data editing with preview and restore.
* Added minimum thickness value with default of 0.001.
* Added automatic update of Data View, Data Graph, Bin Test and Correlogram windows.
* Created new icon.
* Added preference file to remember window locations and sizes.
* Added vector graphics SVG output of graphs.
* Added PNG, BMG, and JPG bitmap output of graphs.

0.0.6 (2011-12-11)
* Added Graph Window.
* Added Thickness Graph.
* Added Growth Graph.
* Added year offsets to Log Window anaylses to assist in locating matches.

0.0.5 (2011-12-03)
* Added 'Precision' command to set precisions in files to avoid precision loss when converting varve to tree-ring format.
* Enabled Analyze and Window commands from Log Window.
* Added Mean Growth command.
* Added Growth Correlation command.
* Modified Bin Test to allow setting of additional filtering parameters, including multiple matches per bin. 
* Added desktop icon.

0.0.4 (2011-11-21)
* Rewrote Trend Percentage algorithm.

0.0.3 (2011-11-20)
* Added Normalize.
* Added Normalized Mean.
* Added Cross-Correlation.
* Added Runs Correlation.
* Added Bin Test.
